# -*- coding: utf-8 -*-
"""
Created on Wed Dec 11 12:11:42 2013

@author: bercherj
"""


from __future__ import division
from __future__ import print_function

from pylab import *
from scipy import signal
from numpy.fft import fft, ifft 
import scipy.signal as sp


def isodd(num):
        return num & 1 and True or False

def repeat(x,n):
    u""" repeat(x,n) -- x ndarray, n integer 
    Répète n fois la séquence x """
    return array([list(x)*n]).flatten()        

def echant(x,step):
    z=zeros(x.shape)
    z[0:len(x):step]=x[0:len(x):step]
    return z


# window can be bartlett, blackman, hamming, hanning, kaiser

def spectrobasic(x,L=256, N=1024, window=hanning(256)):
    """ """
    Nx=size(x)
    k=0
    Xwf=zeros((N/2+1,Nx))+0j #!! force complex type !!
    for n in range(0,Nx-L):
        xw=x[n:n+L]*window
        Xftmp=fft(squeeze(xw),N)
        Xwf[0:N/2+1,k]=Xftmp[0:N/2+1]
        k+=1
    figure()
    imshow(abs(Xwf), aspect='auto', origin='lower',extent=(0, Nx, 0, 0.5) )
    xlabel("Time")
    ylabel("Frequency")
    colorbar()    
    figure()
    plot(x)
    xlabel("Time")
    return Xwf 


def sysfileopen(filepath):
    import subprocess, os
    if sys.platform.startswith('darwin'):
        subprocess.call(('open', filepath))
    elif os.name == 'nt':
            os.startfile(filepath)
    elif os.name == 'posix':
#            subprocess.call(('xdg-open', filepath))
            subprocess.Popen(["xdg-open", filepath])

# Import useful read-write for wav files
from scipy.io.wavfile import read as wavread, write as wavwrite


# En fait ce n'est pas simple du tout de jouer un son sous python... Il y a bien 
# des librairies, mais ce n'est pas direct. Ce n'est pas forcément plus simple 
# sous Matlab d'ailleurs où ce qui fonctionne sous Zin ne fonctionne pas sous Linux
#
# ici je prends le parti suivant : écrire un fichier wav temporaire, et le jouer 
# avec l'application par défaut du système. C'est robuste.
def sound(var):
    from scipy.io.wavfile import write as wavwrite
    scaled = np.int16(var/np.max(np.abs(var)) * 32767)
    stmp=asarray(scaled,dtype=np.int16)
    wavwrite('stmp.wav',8820,stmp)
    sysfileopen("stmp.wav")